#ifndef ARTICLE_H
#define ARTICLE_H

#include "entity.h"
//#include "sale.h"
//#include "seller.h"

#include <memory>
#include <string>

class Seller;
class Sale;

class Article : public Entity
{
  public:
    Article() = default;
    //virtual ~Article() = default;

    void setArticleNo(int articleNo);
    void setPrice(int price);
    void setDescription(const std::string& description);
    bool isSold();
    void setSale(Sale* salePtr);
    void setSeller(Seller* sellerPtr);

    int getArticleNo();
    std::string getDescription();
    Seller* getSeller();
    int getPrice() const;

  private:
    Seller* sellerPtr_{};
    Sale* salePtr_{};
    int articleNo_{};
    int price_{};
    std::string description_{};
};

#endif