#ifndef MARKETPLACE_H
#define MARKETPLACE_H

#include "article.h"
#include "sale.h"
#include "seller.h"

#include <vector>

namespace
{
using SellersVec = std::vector<std::unique_ptr<Seller>>;
using SalesVec = std::vector<std::unique_ptr<Sale>>;
} // namespace

struct Basket {
};

class Marketplace
{
  public:
    Marketplace();
    void storeToDb(bool onlyDelete = false);
    void loadFromDb();
    SellersVec& getSellers();
    int getNextSellerNo();
    int getNumSellersDelete();
    void sortSellers();

  private:
    SellersVec sellers_;
    SalesVec sales_;
};

#endif